;;; BongoDB, an embedded document-based engine
;;; Copyright (C) 2016 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules (bongodb)
	     (srfi srfi-64))

(test-begin "bongodb")

; Definition
(define col (make-collection))
(test-assert (collection? col))

; Insert
(insert col
	'((a . 1) (b . 2))
	'((a . 10) (b . 20))
	'((a . 1) (c . "hello world")))
(test-eqv 3 (count col))

; Search
(test-eqv 3 (length (find col #t)))
(test-eqv 2 (length (find col ($eq 'a 1))))
(test-eqv 1 (length (find col ($and ($eq 'a 1) ($eq 'b 2)))))
(test-eqv 0 (length (find col ($eq 'c "test"))))

(test-eqv 2 (length (find col ($exists 'b))))
(test-eqv 2 (length (find col ($not ($exists 'c)))))

; Update
(update col ($exists 'c) ($set 'c "test"))
(test-eqv 1 (length (find col ($eq 'c "test"))))

(test-end "bongodb")
